import os, pwd, sys, re, socket, time, response, string, psycopg

cnx = psycopg.connect('user=siemer dbname=public')
cr = cnx.cursor()
cr.execute("set search_path to 'rokofo'")
del cr

class xslice(object):
    def __init__(self, *args):
        super(xslice, self).__init__(*args)
        self.slice = slice(*args)
    
    def widen(self, num):
        s = self.slice
        if s.step == None:
            step = 1
        else:
            step = s.step
        if s.start == None:
            start = None
        else:
            if s.start < 0:
                raise NotImplementedError, 'xslice: needs positive slice.start'
            start = s.start - step * num
            if start < 0:
                start = 0
        if s.stop == None:
            stop = None
        else:
            if s.stop < 0:
                raise NotImplementedError, 'xslice: needs positive slice.stop'
            stop = s.stop + step * num
        self.slice = slice(start, stop, step)

    def isone(self):
        s = self.slice
        if s.step != None and s.step != 1:
            raise NotImplementedError, 'xslice: need slice.step == 1'
        if s.stop == None:
            if s.start == -1:
                return True
            else:
                return False
        if s.start == None:
            if s.stop == 1:
                return True
            else:
                return False
        if s.start == -1 and s.stop == 0:
            return False
        if s.start == s.stop-1:
            return True
        else:
            return False

class Config:
    def __init__(self):
        self.basedir='/home/siemer/public_html/gdomain'
        #self.basedir='.'
        # basedir is without trailing slash up to now...
	self.basedir=os.path.abspath(self.basedir)

conf=Config()

class Request:
    def __init__(self):
        self.parse_cgi()
        
    def parse_cgi(self):
	self.path_info = os.environ.get('PATH_INFO')
        if not self.path_info or self.path_info[0] != '/':
            response.error(response.FORBIDDEN, 'Missing sensible PATH_INFO...')
        self.pathArray = self.path_info.split('/')
        for pElem in self.pathArray:
            if pElem.startswith('.'):
                response.error(response.FORBIDDEN,
                               'Path element with starting dot not allowed.')
        self.file = self.pathArray.pop()
        self.fileArray = self.file.split('.')
        type = self.fileArray[-1]
        if len(self.fileArray) > 1 and \
           (type in Image.Types or type in Gallery.Types or type in Resource.Types):
            self.type = self.fileArray.pop()
        else:
            self.type = None
        #path_info ist mind. '/', gereinigt von Apache
        #pathArray ist mind. [''], still cleaned up by Apache
        #file ist mind. ''
        #fileArray is at least [''], possibly trailing dot led to [ ..., '']

class DirEntries:
    '''Becomes a sequence which holds normalized directory entries of %path%.
    Dot-files (i.e. dot-entries) wont turn up and %selectfunc% gets each
    candidate (full path directory entry) for further narrowing.
    The resulting sequence will not contain the %path% for each entry if
    %nopath% is true. Otherwise it will (default).'''

    def __init__(self, path, selectfunc, nopath=None):
        short=filter(lambda entry: not entry.startswith('.'), os.listdir(path))
        op=os.path
        path=op.normpath(path)
        both=map(lambda ent: (op.join(path, ent), ent), short)
        both=filter(lambda bo: selectfunc(bo[0]), both)
        if nopath:
            self.entries=map(lambda bo: bo[1], both)
        else:
            self.entries=map(lambda bo: bo[0], both)

    def __getitem__(self, key):
        return self.entries[key]

def xlcreateDocumentFragment(serial, owner=None):
    reader=xml.dom.ext.reader.Sax2.Reader()
    doc=reader.fromString('<DocumentFragment>'+serial+'</DocumentFragment>',
                          owner)
    df=doc.createDocumentFragment()
    for node in xml.xpath.Evaluate('DocumentFragment/node()', doc):
        df.appendChild(node)
    return df

def dirlist_from_to(frm, to):
    dir2dir(frm, to, 1)

def dir2dir(frm, to, deeper=None):
    op=os.path

    frm=op.normpath(frm).split('/')
    to =op.normpath(to ).split('/')

    if frm[0]=='' or to[0]=='':
        raise GError('relative path needed')
    if frm[0]=='..' or to[0]=='..':
        raise GError("'..' not allowed")
    for i in (frm, to):
        if i[0]=='.':
            i.pop(0)
    try:
        i=0
        while base[i]==deep[i]:
            i+=1
    except IndexError:
        pass
    if deeper:
        if len(frm)!=i:
            raise GError('Only subdirectories allowed.')
        return to[i:len(to)]
    else:
        link=(len(frm)-i)*'../'
        for part in to[i:len(to)]:
            link+=part+'/'
        if not link:
            link='./'
            return link

class GError(Exception):
    pass
class NoRealGalleryError(GError):
    pass
class NoRealImageError(GError):
    pass

class Resource:
    Types={'css': 'text/css'}

class Image:
    Types={'jpg': 'image/jpeg', 'jpeg': 'image/jpeg'}

    def __init__(self, path, mods=[]):
        if path[0] != '/':
            raise NoRealImageError, 'Image accepts only absoult path names.'
        self.path = path
        self.filename = self.path.split('/')[-1]
        self.dirname = os.path.dirname(self.path)
        if self.dirname[-1] != '/':
            self.dirname += '/'
        f = self.filename.split('.')
        if len(f) >= 2:
            self.name = '.'.join(f[0:-1])
            self.type = f[-1]
        else:
            self.name = self.filename
            self.type = ''

        self.modifications = []
        self.state = 0
        self.mods_good = True
        self.modify(mods)

    def __str__(self):
        return self.path

    def __eq__(self, other):
        return self.name == other.name

    def __ne__(self, other):
        return self.name != other.name

    def __nonzero__(self):
        return self.mods_good

    def __getitem__(self, key):
        if key == 'relpath':
            return self.path[len(conf.basedir)+1:]
        else:
            raise AttributeError, 'Attribute does not exist'

    def persons(self):
        cr = cnx.cursor()
        cr.execute('select name from filePerson where path = %(relpath)s',
                   self)
        names = map(lambda x: x[0], cr.fetchall())
        return ', '.join(names)

    def ack_mod(self, mod, state):
        self.state = state
        self.modifications.append(mod)
        return True

    def modify(self, mod):
        if isinstance(mod, (list, tuple)):
            return self.arrayModify(mod)
        else:
            return self.flatModify(mod)

    def arrayModify(self, mods):
        for mod in mods:
            if not self.flatModify(mod):
                self.mods_good = False
        return self.mods_good


    def flatModify(self, mod):
        if self.state == 0:
            self.size = re.search(
                '(?P<height>^h\d{1,4}$)|'
                '(?P<width>^w\d{1,4}$)|'
                '(?P<resolution>^\d{1,4}x\d{1,4}$)'
                , mod)
            if self.size:
                return self.ack_mod(mod, 1)
        if self.state <= 1:
            self.argument=mod
            self.argument=False
            if self.argument:
                return self.ack_mod(mod, 2)
        return False

    def order(self):
        resize='-resize '
        if 'size' in dir(self) and self.size:
                [what_arg]=filter(lambda x: x[1],
                                  self.size.groupdict().iteritems())
                if what_arg[0] == 'width':
                        resize+=what_arg[1][1:]
                elif what_arg[0] == 'height':
                        resize+='x' + what_arg[1][1:]
                else:
                        resize+=what_arg[1]
                size='.' + what_arg[1]
        else:
                resize=''
                size=''

        modifiedPath = self.dirname + '.modified/'
        if not os.path.exists(modifiedPath):
            try:
                os.mkdir(modifiedPath)
            except OSError, (errno, str):
                if errno != 17:
                    raise

        self.target = modifiedPath + self.name + size + '.' + self.type

        # -size 120x120 (only if resize is known) -strip -resize x200
        # +comment +profile "*" -resize x200
        order('convert +comment +profile "*" ' + resize + ' ' + self.path + ' -',
              self.target)

    def read(self, *args):
        self.order()
        op = os.path
        while not op.isfile(self.target) or not op.getsize(self.target):
            time.sleep(0.2)
        else:
            f = file(self.target)
            self.read = f.read
            return f.read(*args)
        
class Gallery:
    Types={'html': 'text/html', 'xhtml': 'application/xhtml+xml'}
    
    def __init__(self, config, path, date=None):
        self.config=config
        self.path=path
        self.date=date
        if self.date==None:
            self.datescan()

    def __str__(self):
        return 'Gallery instance at '+self.path+' with date '+str(self.date)

    def isimage(self, file):
        return os.path.isfile(file) and \
               file.split('.')[-1].lower() in Image.Types

    def datescan(self):
        dates=map(lambda de: os.stat(de).st_mtime,
                  DirEntries(self.path, self.isimage))
        try:
            self.date=max(dates)
        except ValueError:
            raise NoRealGalleryError('No image I could take date from...')

    def __getitem__(self, key):
        self.scan()
        return self[key]

    def index(self, image):
        self.scan()
        return self.index(image)

    def _index_(self, image):
        for n in range(len(self.images)):
            if self.images[n] == image:
                return n
        raise ValueError, 'Image not in Gallery'

    def _getitem_(self, key):
        return self.images[key]

    def scan(self):
        self.images=[]
        for i in DirEntries(self.path, self.isimage):
            self.images.append(Image(i))
        self.__getitem__ = self._getitem_
        self.index = self._index_

##    def dirlist_to_path_from(self, base):
##        op=os.path
##        deep=filter(None, op.realpath(op.abspath(self.path)).split('/'))
##        base=filter(None, op.realpath(op.abspath(base)     ).split('/'))
##        try:
##            i=0
##            while base[i]==deep[i]:
##                i+=1
##        except IndexError:
##            pass
##        return deep[i:len(deep)]

    def title(self, base=None):
        try:
            return file(self.path+'.title').read()
        except IOError:
            return self.path[len(self.config.basedir)+1:]

        ##### old code
        if not base:
            base=self.config.basedir + '/'
        title=[]
        dirlist=self.path[len(base)-1:].split('/')
        # dirlist=dirlist_from_to(base, self.path)
        # dirlist.insert(0, '.')
        for level in dirlist:
            base+='/'+level
            try:
                title.append(file(base+'/.title').read())
            except IOError:
                self.title.append(level)
        if not title:
            title.append(dirlist[-1])  # name it like the directory
        return title
    

    def title_node(self, doc=None, base=None):
        title=''
        for part in self.title(base):
            title+=part+' '
        title.strip()
        title=xlcreateDocumentFragment(title, doc)
        a_elements=xml.xpath.Evaluate('a', title)
        if not a_elements:
            # add one <a> around
            a=title.ownerDocument.createElement('a')
            for child in title.childNodes:
                a.appendChild(child)
            title.appendChild(a)
        else:
            # leave just the last <a ...>
            while len(a_elements)>1:
                a=a_elements.pop(0)
                df=title.ownerDocument.createDocumentFragment()
                for child in a.childNodes:
                    df.appendChild(child)
                title.replaceChild(df, a)
            #title.normalize()
            a=a_elements[0]
        a.setAttribute('href', dir2dir(req.rel_url,
                                       os.path.normalize(self.path+'')))

        return title

class Dummy:
    pass

class SqlGallery:
    def __init__(self, config, dir, rootRef=''):
        self.rootRef = rootRef
        self.config  = config
        self.path = dir
        self.localgallery = Dummy()
        self.localgallery.path = self.path
        self.localgallery.images=[Image(), Image()]
        self.galleries = [self.localgallery]

class GalleryContainer:
    def __init__(self, config, dir, rootRef=''):
        self.rootRef = rootRef
        self.config    = config
        self.path = dir
        self.galleries = []
        self.localgallery=None
        self.scan()

    def __getitem__(self, key):
        return self.galleries[key]

    def sort(self):
        tmplist=[(g.date, g.path, g) for g in self.galleries]
        tmplist.sort()
        tmplist.reverse()
        self.galleries = [g for (date, path, g) in tmplist]

    def scan(self):
        for node in DirEntries(self.path, os.path.isdir):
            node += '/'
            node_sub_container=GalleryContainer(self.config, node,
                                                self.rootRef + '../')
            if os.path.isfile(node+'.title'):
                # don't make sublists from this dir
                node_sub_container.sort()
                date=node_sub_container[0].date
                self.galleries.append(Gallery(self.config, node, date))
            else:
                self.galleries[0:0]=node_sub_container
        try:
            self.localgallery=Gallery(self.config, self.path)
        except NoRealGalleryError:
            pass
        else:
            self.galleries.append(self.localgallery)

class SimplePresenter:
    def __init__(gallery_container):
        # read template
        reader=xml.dom.ext.reader.Sax2.Reader()
        doc=reader.fromUri('SimplePresenter.xhtml')
        # customize template
        glist=xml.xpath.Evaluate('ul[@id="galleries"]', doc)
        for gal in gallery_container:
            li=glist.ownerDocument.createElement('li')
            li.appendChild(gal.title_node(glist.ownerDocument))
            glist[0].appendChild(li)
        plist=xml.xpath.Evaluate('p[@id="pictures"]', doc)
        if gallery_container.localgallery:
            for image in gallery_container.localgallery:
                img=glist.ownerDocument.createElement('img')
                img.setAttribute('alt', 'Photo')
                img.setAttribute('href', image.something(xxxxxx))
                a=glist.ownerDocument.createElement('a')
                a.setAttribute('href', image.path(xxxxx))
                a.appendChild(img)
                plist[0].appendChild(a)

        style=reader.fromUri('SimplePresenter.xslt')
        processor=xml.xslt.Processor()
        processor.appendStylesheet(style)
        print processor.run(doc)

class HtmlWriter:
    def __init__(self, conf, gc):
        self.config=conf
        self.gallerycontainer=gc
        

    def write(self):
        self.config.xhtml
        print preamble
        print 
        print self.dirs
        print self.pics

def normalize(path):
	'''Interprests path as URL or file system path - (path-)relative or
	(path-)absolut and normalises it. Does not normalise more than it
	should! - Does not skip leading .. and does not skip trailing
	/. - Is buggy. Does not respect leading ..'''
	
	# '' stays ''
	if not path: return path
	path=path.split('/')
	# short pathes to care about: ['', ''], ['xyz']
	if path[0] == '':
		absolut=1
	else:
		absolut=0
	if path[-1] in ('', '.', '..'):
		directory=1
	else:
		directory=0
	try:
		while 1:
			path.remove('')
	except ValueError:
		pass
	try:
		while 1:
			path.remove('.')
	except ValueError:
		pass
	try:
		while 1:
			index = path.index('..', 1)
			del path[index]
			del path[index-1]
	except ValueError:
		pass
	if directory:
		path.append('')
	if absolut:
		path.insert(0, '')
	if path.len()==1 and path[0]=='':
		if absolut:
			return '/'
		elif directory:
			return './'
		else:
			return '.'
	else:
		return '/'.join(path)

def order(command, file):
	s=socket.socket(socket.AF_UNIX)
	s.connect('/tmp/gdomain2-unix')
	s.send(command + '\n' + file + '\n')

def handle_resource(req):
    if req.pathArray != [''] or req.file == '':
    	return False
    # basedir + pathArray works because latter carries leading slash
    resource = conf.basedir + '/' + req.file

    dic = Resource.Types.copy()
    dic.update(Image.Types)
    dic.update(Gallery.Types)

    if req.type:
        if not os.path.isfile(resource):
	    if req.type in Resource.Types:
            	response.error(response.NOTFOUND, 'Resource not found.')
		return True
	    else:
	    	return False
    else:
        for ending in dic:
            if os.path.isfile(resource + '.' + ending):
                req.type = ending
		resource += '.' + ending
                break
        else:
            if os.path.isfile(resource):
		response.content('text/plain', file(resource))
		return Ture
            else:
                return False

    response.content(dic[req.type], file(resource))	
    return True

def handle_picture(req):
    if req.type and req.type not in Image.Types:
        return
    # basedir + pathArray works because latter carries leading slash
    picture_path = conf.basedir + '/'.join(req.pathArray) + '/'
    if not os.path.isdir(picture_path):
        if req.type:
            response.error(response.NOTFOUND, 'Directory does not exist.')
        else:
            return
    else:
        req.galleryPath = picture_path
        req.rootRef = len(req.pathArray)-1
        req.pathArray=[]

    n = req.fileArray[0]  # name of picture
    if req.type:
        if not os.path.isfile(req.galleryPath + n + '.' + req.type):
            response.error(response.NOTFOUND, 'Picture not found.')
    else:
        for ending in Image.Types:
            if os.path.isfile(req.galleryPath + n + '.' + ending):
                req.type = ending
                break
        else:
            return

    # It's a picture request!
    image = Image(req.galleryPath + req.fileArray.pop(0) + '.' + req.type,
                  req.fileArray)
    if not image:
        response.error(response.FORBIDDEN, 'Unknown picture argument.')
    else:
        response.content(Image.Types[image.type], image)	

def handle_index(req):
    try:
        req.galleryPath
    except AttributeError:
        req.galleryPath = conf.basedir + '/'
        req.rootRef = 0

    if req.pathArray and not req.pathArray[0]:   # kick empty entry from front
        req.pathArray.pop(0)

    while req.pathArray:
        if os.path.isdir(req.galleryPath + req.pathArray[0] + '/'):
            req.galleryPath += req.pathArray.pop(0) + '/'
            req.rootRef += 1
        else:
            if req.pathArray[0].startswith('SQL'):
                req.rootRef = 0
                req.galleryPath = reg.pathArray.pop(0)
                sql = 1
            break

    if req.fileArray == ['']:
        req.fileArray = []
    ln = LayerNavigator(req.pathArray, req.fileArray, req.type)
    req.rootRef *= '../'
    if 'sql' in vars():
        gc = SqlGallery(conf, req.galleryPath, req.rootRef)
    else:
        gc = GalleryContainer(conf, req.galleryPath, req.rootRef)
    gc.sort()

    try:
        layout = __import__('layout.' + ln.currentLayout(),
                            globals(), locals(), [''])
    except ImportError:
        response.error(response.NOTFOUND, 'Layout unknown...')
        
    layout = layout.layout(ln)
    if not layout.modify(ln.layoutArguments()):
        response.error(response.FORBIDDEN, 'Layout arguments unknown...')

    layout.gallery(gc, ln.layoutPosition(gc.localgallery))
    layout.response()

class LayerNavigator:
    def __init__(self, requestArray, requestFileArray, requestType):
        self.request = requestArray
        self.fileArguments= requestFileArray
        self.type = requestType

        # 1) default, easy
        # /overview(=200x200.all)/[whatever] --> /around/[whatever]
        #       --> /fullsize/[whatever]
        #
        # 2) default, more like explicit
        #   -makes only sense with easy change to one-letter-indicator (expli)
        # /[:empty-only] --> /overview/around/[egal]
        #                --> /overview/around/fullsize/[egal]
        #
        # 3) explicit
        # Recognition by one-letter-indicator (empty-exception)
        # /overview/400x400/800x800/[:empty-only]
        #                            --> /overview/400x400/800x800/b.dscn0100
        #                            --> /overview/400x400/800x800/c.dscn0100

        self.layers = ['overview', 'around', 'fullsize']
        l = len(self.request)
        self.rootRef = l*'../'

        if l > 26:
            response.error(response.TOOLONG, "I don't handle so much layers...")
        elif self.fileArguments and len(self.fileArguments[0]) == 1 and \
                 self.fileArguments[0] in string.ascii_lowercase[0:l]:
            self.position = string.ascii_lowercase.index(
                self.fileArguments.pop(0))
            self.layers = self.request
            self.mode = 3
        elif l == 0:
            self.position = 0
            self.mode = 2
        elif l == 1 and self.request[0] in self.layers:
            self.position = self.layers.index(self.request[0])
            self.mode = 1
        else:
            if self.request == self.layers[0:l]:
                self.position = l-1
                self.mode = 2
            else:
                self.position = 0
                self.layers = self.request
                self.mode = 3

        aliases = {'overview': 'basic.300x300', 'fullsize': 'basic.800x600'}
        l = self.layers[self.position]
        self.layout = aliases.get(l, l).split('.')

        self.down = self.position < len(self.layers)-1

    def currentLayout(self):
        return self.layout[0]

    def layoutArguments(self):
        return self.layout[1:]

    def layoutPosition(self, gallery):
        if self.fileArguments == ['index']:
            return xslice(None)  # all
        elif self.fileArguments and getattr(gallery, 'path', None):
            image = Image(gallery.path + self.fileArguments[0])
            try:
                where = gallery.index(image)
            except ValueError:
                return xslice(0)  # none
            else:
                return xslice(where, where+1)  # one
        elif self.fileArguments:
            return xslice(0)
        else:
            return xslice(None)


#    def __getitem__(self, key):
#        return self.layout[key]

    def galleryDown(self, gallery):
        ref = self.rootRef + gallery + '/'.join(self.request) + '/'
        if not self.request:
            ref = ref[0:-1]
        if self.mode == 3:
            ref += string.ascii_lowercase[self.position]
        elif self.type:
            ref += 'index'

        if self.type:
            ref += '.' + self.type

        return ref

    def imageDown(self, image):
        if self.mode == 1:
            ref = self.rootRef + self.layers[self.position+1] + '/' + image.name
        elif self.mode == 2:
            ref = '/'.join(self.layers[len(self.request):self.position+2]) + \
                  '/' + image.name
        else:
            ref = string.ascii_lowercase[self.position+1] + '.' + image.name

        if self.type:
            ref += '.' + self.type

        return ref

    def imageSource(self, image):
        if self.type:
            type = '.' + image.type
        else:
            type = ''
        return self.rootRef + '.'.join([image.name] +image.modifications) + type

    def imageLoop(self, image):
        if self.mode == 3:
            ref = string.ascii_lowercase[self.position] + '.'
        else:
            ref = ''

        ref += image.name

        if self.type:
            ref += '.' + self.type

        return ref
